[pass] ignore previous gpg4win patch, this one contains an additional fix

Lenz Weber mail at lenzw.de
Tue Sep 23 14:28:03 CEST 2014


this works now with gpg4win converting cygwin paths to windows paths. 
I had to change an "exec $GPG" to "$GPG" as exec will not execute a function. please check if this impacts any behaviour

additional minor fix: gpg_winpath will apply to nonexisting output files now as well. calling "generate" would fail before
---
 src/password-store.sh  |  2 +-
 src/platform/cygwin.sh | 24 ++++++++++++++++++++++++
 2 files changed, 25 insertions(+), 1 deletion(-)

diff --git a/src/password-store.sh b/src/password-store.sh
index 851b371..3dea599 100755
--- a/src/password-store.sh
+++ b/src/password-store.sh
@@ -320,7 +320,7 @@ cmd_show() {
 	check_sneaky_paths "$path"
 	if [[ -f $passfile ]]; then
 		if [[ $clip -eq 0 ]]; then
-			exec $GPG -d "${GPG_OPTS[@]}" "$passfile"
+			$GPG -d "${GPG_OPTS[@]}" "$passfile"
 		else
 			local pass="$($GPG -d "${GPG_OPTS[@]}" "$passfile" | head -n 1)"
 			[[ -n $pass ]] || exit 1
diff --git a/src/platform/cygwin.sh b/src/platform/cygwin.sh
index 05c51e0..7915f0b 100644
--- a/src/platform/cygwin.sh
+++ b/src/platform/cygwin.sh
@@ -14,3 +14,27 @@ clip() {
 	) 2>/dev/null & disown
 	echo "Copied $2 to clipboard. Will clear in $CLIP_TIME seconds."
 }
+
+#replaces Cygwin-style filenames with their Windows counterparts
+gpg_winpath(){
+    args=("$@")
+	#as soon as an argument (from back to front) is no file, it can only be a filename argument if it is preceeded by '-o'
+	could_be_filenames="true"
+	
+	for ((i=${#args[@]}-1; i>=0; i--)); do
+        if ( [ $i -gt 0 ] && [ "${args[$i-1]}" = "-o" ] )  || ([ $could_be_filenames = "true" ] && [ -e  ${args[$i]} ]) ; then
+			args[$i]=$(cygpath -am ${args[$i]})
+
+			[ -e  ${args[$i]} ] || could_be_filenames="false"
+       fi
+    done
+
+	$GPG_ORIG "${args[@]}"
+}
+
+if $GPG --help | grep -q Gpg4win; then
+	GPG_ORIG=$GPG
+	GPG=gpg_winpath
+fi
+
+
-- 
2.1.0



More information about the Password-Store mailing list